hdu 2680 最短路径(dijkstra算法+多源最短路径单源化求最小值)

Choose the best route

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 7062    Accepted Submission(s): 2301


Problem Description
One day , Kiki wants to visit one of her friends. As she is liable to carsickness , she wants to arrive at her friend’s home as soon as possible . Now give you a map of the city’s traffic route, and the stations which are near Kiki’s home so that she can take. You may suppose Kiki can change the bus at any station. Please find out the least time Kiki needs to spend. To make it easy, if the city have n bus stations ,the stations will been expressed as an integer 1,2,3…n.
 

 

Input
There are several test cases.
Each case begins with three integers n, m and s,(n<1000,m<20000,1=<s<=n) n stands for the number of bus stations in this city and m stands for the number of directed ways between bus stations .(Maybe there are several ways between two bus stations .) s stands for the bus station that near Kiki’s friend’s home.
Then follow m lines ,each line contains three integers p , q , t (0<t<=1000). means from station p to station q there is a way and it will costs t minutes .
Then a line with an integer w(0<w<n), means the number of stations Kiki can take at the beginning. Then follows w integers stands for these stations.
 

 

Output
The output contains one line for each data set : the least time Kiki needs to spend ,if it’s impossible to find such a route ,just output “-1”.
 

 

Sample Input
5 8 5 1 2 2 1 5 3 1 3 4 2 4 7 2 5 6 2 3 5 3 5 1 4 5 1 2 2 3 4 3 4 1 2 3 1 3 4 2 3 2 1 1
 

 

Sample Output
1 -1
 

 

Author
dandelion
 

 

Source
 

 

Recommend
lcy   |   We have carefully selected several similar problems for you:  2112 1874 2544 1217 2066 
 
AC代码及重点讲解:
#include<stdio.h>
#include<string.h>
#define max 0x3f3f3f3f
int map[1002][1002];
int dist[1002];
void dijkstra(int n,int v)
{
 bool vis[1002];
 int i,j;
 for(i=0;i<=n;i++)//i从0开始了
 {
  dist[i]=map[v][i];
  vis[i]=0;
 }
 dist[v]=0;
 vis[v]=1;
 for(i=0;i<=n;i++)//i从0开始了
 {
  int tmp=max;
  int u=v;
  for(j=0;j<=n;j++)//j从0开始了
   if((!vis[j])&&dist[j]<tmp)
   {
    u=j;
    tmp=dist[j];
   }
  vis[u]=1;
  for(j=0;j<=n;j++)//j从0开始了
   if((!vis[j])&&map[u][j]<max)
   {
    int newdist=dist[u]+map[u][j];
    if(newdist<dist[j])
     dist[j]=newdist;
   }
 }
}
int main()
{
 int t,m,s;
 while(scanf("%d%d%d",&t,&m,&s)!=EOF)
 {
  memset(map,max,sizeof(map));
  int i,j,a,b,time;
  for(i=0;i<m;i++)
  {
   scanf("%d%d%d",&a,&b,&time);
   if(map[a][b]>time)
    map[a][b]=time;//该题为有向图,所以在赋值上是单向的
  }
  int x;
  scanf("%d",&x);
  for(i=0;i<x;i++)//重点,这题刚开始给人的感觉就是多源最短路径求最小值,但
  {                     是如果按照上述的方向写代码的话会出现超时的情况,所以
   int start; 此处是该题对多源最短路径单源化(自己命名)的一种方式
   scanf("%d",&start); 由于该题说有s个车站时紧邻着主人公Kiki的家的
   map[0][start]=0; 所以我们自然会将s个车站看成是起点,但是那样
  }    超时,所以我们将之单源化,因为不论从哪个车站出发
  dijkstra(t,0);   都可以看成是从家出发到车站栽倒目的地的,则将0点作为家 
  if(dist[s]==max)  由于实际上的起点应该是车站,家只是我们用来简化这道题的
   printf("-1 ");  解法的一种方式,所以0点到车站所对应的点的距离全部赋值为0
  else     而到其他点的距离全赋值为无穷大。相应的在dijkstra()
   printf("%d ",dist[s]);  函数中也会有变化。
 }
 return 0;
}
原文地址:https://www.cnblogs.com/hbutACMER/p/3911964.html